# HS2024 - Seminar Cryptocurrencies and Smart Contracts

Please see the [ILIAS module](https://ilias.unibe.ch/goto.php?target=crs_3102234) of the seminar for all other information.

## List of Selected Projects

| Project | Members | Git Repository | Testing | Presentation Data |
| ------ | ------ | ------ | ------ | ------ |
|  BitVM      |   Roman Bögli     |   [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-bitvm)     |    Team ATOM (Sascha Künzler & Cécile Semelet)     |    6. Nov. 2024    |
|   Ethereum (ETH)     |   Owen Gombas & Arthur Gygax     |  [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-eth)      |    Team ATOM (Sascha Künzler & Cécile Semelet) and Team FIL (Raphael Fehr)    |    6. Nov. 2024     |  
|   Cardano (ADA)     |   Michal Stetina & David Gallardo     |   [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-ada)     |   Team ARB (Martin Stojkovski & Filipe Silva)    |   13. Nov. 2024     | 
|    Avalanche (AVAX)     |   Marcel Haag & Jan Koch     |    [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-avax)    |  Team ARB (Martin Stojkovski & Filipe Silva) and Team LINK (Zsófia Tasnádi-Tulogdi)     |    13. Nov. 2024    | 
|    Binance Smartchain (BNB)     |    Daniele De Jeso    |   [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-bnb)     |    Team ETH (Owen Gombas & Arthur Gygax)   |    20. Nov. 2024     | 
|   Internet Computer (ICP)     |      Vladyslav Kvochkin & Niklas Radomski  |    [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-icp)    |   Team BitVM (Roman Bögli) and Team ETH (Owen Gombas & Arthur Gygax)     |   20. Nov. 2024     | 
|   Stellar (XLM)     |    Tishana Suthenthiran and Michael Meyer    |  [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-xlm)      |   Team ADA (Michal Stetina & David Gallardo) and Team AVAX (Marcel Haag & Jan Koch)    |   27. Nov. 2024    | 
|    ZkSync (ZK)     |     Peter Brühwiler   |  [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-zk)      |  Team ADA (Michal Stetina & David Gallardo) and Team AVAX (Marcel Haag & Jan Koch)     |   27. Nov. 2024     | 
|    Cosmos (ATOM)     |    Sascha Künzler & Cecile Semelet    |    [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-atom)    |   Team BNB (Daniele De Jeso) and Team ICP (Vladyslav Kvochkin & Niklas Radomski)    |   04. Dec. 2024     | 
|    Filecoin (FIL)     |     Raphael Fehr    |   [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-fil)     |   Team ICP (Vladyslav Kvochkin & Niklas Radomski)    |   04. Dec. 2024     | 
|    Arbitrum (ARB)    |    Martin Stojkovski & Filipe Silva    |   [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-arb)     |   Team XLM (Tishana Suthenthiran and Michael Meyer) and Team ZK (Peter Brühwiler)     |   11. Dec. 2024     | 
|   Chainlink (LINK)      |     Zsófia Tasnádi-Tulogdi     |    [Link](https://gitlab.inf.unibe.ch/crypto-public/sem-crypto-hs24-link)    |   Team XLM (Tishana Suthenthiran and Michael Meyer)    |   11. Dec. 2024      | 

## List of Layer-1 Projects

| Blockchain | Organization and Network | Documentation | Testnets | Smart-contract Programming | Podcast |
| ------ | ------ | ------ |  ------ | ------ | ------ |
|  Ethereum (ETH)  |  [Ethereum Foundation](https://ethereum.org/)  |  [Whitepaper](https://ethereum.org/en/whitepaper/); [Consensus Evolution Blog](https://github.com/ethereum/pos-evolution/blob/master/pos-evolution.md); [Upgrading Ethereum Book](https://eth2book.info/latest/)  |  [List of Testnets](https://www.alchemy.com/list-of/testnets-on-ethereum); [Another list](https://moralis.io/ethereum-testnet-full-ethereum-test-network-guide/)  |  [Tutorial](https://www.web3.university/tracks/create-a-smart-contract/deploy-your-first-smart-contract); [Hardhat development environment](https://hardhat.org)  |
|  <del>Binance Smartchain (BNB)</del>  |  [BNBChain](https://www.bnbchain.org/en)  |  [Whitepaper](https://github.com/bnb-chain/whitepaper/blob/master/WHITEPAPER.md); [Docs](https://docs.bnbchain.org/bnb-smart-chain/)  |  TBD  |  TBD  |
|  <del>Solana (SOL)</del>  |  [Solana](https://solana.com)  |  [Whitepaper](https://solana.com/solana-whitepaper.pdf); [Docs](https://solana.com/docs); [Analysis paper](https://doi.org/10.1145/3631461.3631553)  |  TBD  |  TBD  |
|  XRP Ledger (XRP)  |  [Ripple](https://ripple.com); [XRP Ledger](https://xrpl.org)  |  [Consensus docs](https://xrpl.org/docs/concepts/consensus-protocol); [Analysis paper](https://doi.org/10.4230/LIPIcs.OPODIS.2020.10)  |  [Testnets](https://xrpl.org/resources/dev-tools/xrp-faucets/)  |  [Hooks](https://xrpl-hooks.readme.io/docs/introduction)  |  [Defiant: Revisiting Ripple](https://thedefiant.io/podcasts-and-videos/podcast/revisiting-ripple-new-stablecoin-airdrops-network-attacks-and-the-sec-case)  |
|  Cardano (ADA)  |  [Input-Output](https://iohk.io); [Cardano Foundation](https://cardanofoundation.org/); [Cardano Ecosystem](https://cardano.org/)  |  [Protocol docs](https://docs.cardano.org/about-cardano/new-to-cardano/proof-of-stake/); [Papers](https://docs.cardano.org/about-cardano/explore-more/relevant-research-papers/)  |  [Testnets](https://docs.cardano.org/cardano-testnets/getting-started/)  |  [Introduction](https://developers.cardano.org/docs/smart-contracts/)  |  [Lex Fridman #192](https://lexfridman.com/charles-hoskinson/)  |
|  Avalanche (AVAX)  |  [Ava Labs](https://www.avalabs.org); [AVAX Network](https://www.avax.network/)  |  [Protocol docs](https://docs.avax.network/learn/avalanche-consensus);  [Analysis paper](https://arxiv.org/abs/2401.02811)  |  [Fuji Testnet](https://docs.avax.network/build/subnet/deploy/fuji-testnet-subnet)  |  [Tutorial](https://docs.avax.network/build/dapp/smart-contracts/remix-deploy)  |  [ZK 214](https://zeroknowledge.fm/214-2/); [Empire 19.12.23](https://blockworks.co/podcast/empire/abd0f70c-9e28-11ee-a140-fbdaddeaa54a)  |
|  Polkadot (DOT)  |  [Web3 Foundation](https://web3.foundation); [Polkadot](https://polkadot.network/)  |  [Lightpaper](https://assets.polkadot.network/Polkadot-lightpaper.pdf);  [Protocol docs](https://wiki.polkadot.network/docs/learn-index)  |  [Testnets](https://wiki.polkadot.network/docs/maintain-networks)  |  [Tutorial](https://wiki.polkadot.network/docs/build-smart-contracts)   |  [ZK 171](https://zeroknowledge.fm/171-2/); [ZK 229](https://zeroknowledge.fm/229-2/)  |
|  Internet Computer (ICP)  |  [DFINITY](https://dfinity.org/);  [Internet Computer](https://internetcomputer.org)  |  [Whitepaper](https://internetcomputer.org/whitepaper.pdf); [Docs](https://internetcomputer.org/docs/current/home)  |  [Local Testnet](https://internetcomputer.org/docs/current/developer-docs/getting-started/deploy/local)  |  [Developer docs](https://internetcomputer.org/docs/current/home)  |  [Epicenter 406](https://epicenter.tv/episodes/406)  |
|  Stellar (XLM)  |  [Stellar](https://stellar.org/)  |  [Whitepaper (see PDF inside)](https://stellar.org/learn/stellar-consensus-protocol); [Consensus docs](https://developers.stellar.org/docs/learn/fundamentals/stellar-consensus-protocol)  |  [Testnet](https://developers.stellar.org/docs/learn/fundamentals/networks)  |  [Soroban](https://stellar.org/soroban); [Docs](https://stellar.org/learn/smart-contract-basics)  |
|  Filecoin (FIL)  |  [Protocol Labs](https://protocol.ai); [Filecoin](https://filecoin.io/)  |  [Whitepaper](https://filecoin.io/filecoin.pdf);  [Protocol docs](https://docs.filecoin.io/);  [Consensus docs](https://docs.filecoin.io/basics/interplanetary-consensus)  |  [Testnet](https://docs.filecoin.io/basics/what-is-filecoin/networks)  |  [Developer docs](https://fvm.filecoin.io/)  |  [ZK 106](https://zeroknowledge.fm/106-2/)   |
|  Cosmos (ATOM)  |  [Interchain Foundation](https://interchain.io/technology); [Cosmos](https://cosmos.network)  |  [Cosmos introduction](https://tutorials.cosmos.network/academy/1-what-is-cosmos/); [Tendermint/CometBFT](https://docs.cometbft.com/); [IBC](https://arxiv.org/pdf/2006.15918); [Whitepaper (outdated)](https://github.com/cosmos/cosmos/blob/master/WHITEPAPER.md); [Apps](https://tutorials.cosmos.network/academy/2-cosmos-concepts/1-architecture.html)  |  [App Testnet](https://docs.cosmos.network/v0.50/build/building-apps/app-testnet)  |  [ABCI](https://docs.cosmos.network/v0.50/build/abci/introduction) |  [ZK 193](https://zeroknowledge.fm/193/); [ZK 207](https://zeroknowledge.fm/episode-207-journey-through-the-cosmos-ecosystem-with-billy-rennekamp/); [ZK 340](https://zeroknowledge.fm/340-2/)  |


## List of Layer-2 Projects

| Layer-2 Project | Organization and Network | Documentation | Testnets | Programming | Podcast |
| ------ | ------ | ------ | ------ | ------ | ------ |
|  Arbitrum (ARB)  |  [Offchain Labs](https://www.offchainlabs.com); [Arbitrum](https://arbitrum.io/)  |  [Academic Paper](https://www.usenix.org/system/files/conference/usenixsecurity18/sec18-kalodner.pdf);  [Whitepaper](https://docs.arbitrum.io/how-arbitrum-works/inside-arbitrum-nitro); [Docs](https://docs.arbitrum.io/)  |  [Local Testnet](https://docs.arbitrum.io/stylus/reference/testnet-information)  |   [Tutorial](https://docs.arbitrum.io/build-decentralized-apps/quickstart-solidity-hardhat)  |  [ZK 179](https://zeroknowledge.fm/179-2/)  |
|  <del>Optimism (OP)</del>  |  [Optimism](https://www.optimism.io)  |  [Specs](https://specs.optimism.io); [Docs](https://docs.optimism.io)  |  [Create testnet](https://docs.optimism.io/builders/chain-operators/tutorials/create-l2-rollup)  |  [OP Stack](https://docs.optimism.io/stack/getting-started)  |  [ZK 177](https://zeroknowledge.fm/177-2/)   |
|  Starknet (STRK)  |  [Starkware](https://starkware.co/stark/); [Starknet](https://www.starknet.io)  |  [Book](https://book.starknet.io/title-page.html); [Docs](https://docs.starknet.io)  |  [Tutorial](https://book.starknet.io/ch01-00-getting-started.html)  |  [Cairo language](https://starkware.co/cairo/)  |  [ZK 96](https://zeroknowledge.fm/96-2/); [ZK 329](https://zeroknowledge.fm/329-2/)  |
|  ZkSync (ZK)  |  [Matter Labs](https://matter-labs.io); [ZkSync](https://zksync.io/)  |  [Docs](https://docs.zksync.io); [Quickstart](https://docs.zksync.io/build/)  |  [Testnets](https://docs.zksync.io/ecosystem/network-faucets)  |  [Tutorial](https://docs.zksync.io/build/start-coding/quick-start)  |  [ZK 116](https://zeroknowledge.fm/116-2/); [ZK 299](https://zeroknowledge.fm/299-2/)  |


## Further Projects (Oracle, Layer 3, Decentralized Finance)

| Project | Type | Organization and Network | Documentation | Testnets | Programming | Podcast |
| ------ | ------ | ------ | ------ | ------ | ------ | ------ |
|  Chainlink (LINK) | Oracle Network (Data feeds & CCIP) |  [Chainlink Labs](https://chainlinklabs.com); [Chainlink](https://chain.link/)  |  [Whitepaper](https://research.chain.link/whitepaper-v1.pdf); [Whitepaper 2.0](https://chain.link/whitepaper); [Off-chain Reporting](https://docs.chain.link/architecture-overview/off-chain-reporting); [Data Feeds](https://docs.chain.link/data-feeds); [CCIP](https://docs.chain.link/ccip)  |  [Developer docs](https://docs.chain.link/getting-started/conceptual-overview);  [Tutoarial](https://github.com/smartcontractkit/hardhat-starter-kit)  |  [Consuming data feeds](https://docs.chain.link/data-feeds/getting-started); [Sending data with CCIP](https://docs.chain.link/ccip/getting-started) * |  [Lex Fridman 181](https://lexfridman.com/sergey-nazarov); [Bellcurve 8.3.24](https://blockworks.co/podcast/bellcurve/c7ccf042-dced-11ee-abf7-e7bd340d6fdf)  |
|  Celestia (TIA)  |  Data Availability Layer  |  [Celestia](https://celestia.org)  |  [Whitepaper](https://arxiv.org/abs/1905.09274); [Fraud proofs and DA proofs](https://arxiv.org/abs/1809.09044); [Run a light node](https://docs.celestia.org/nodes/light-node)  |  [Run a light node](https://celestia.org/run-a-light-node/)  |  Not possible*  |  [ZK 311](https://zeroknowledge.fm/311-2/)  |
|  <del>EigenLayer (future: EIGEN)</del>  |  Restaking, esp. Data Availability  |  [EigenLayer](https://www.eigenlayer.xyz/)  |  [Whitepapers](https://docs.eigenlayer.xyz/eigenlayer/overview/whitepaper); [Docs](https://docs.eigenlayer.xyz)  |  [Local Testnet](https://medium.com/@ilaNihas/eigenlayer-a-step-by-step-guide-to-testnet-node-setup-e242f4e35344)  |  Not possible*  |  [ZK 301](https://zeroknowledge.fm/301-2/)  |

*Note: Some of the networks cannot be programmed. Possible projects for those networks will be discussed with the teachers (for example: demonstrate a core functionality).


## Additional Material

### Recommended podcasts

Many projects have their own podcast. The links in the table are mostly to the highly recommended [Zeroknowledge.fm](https://zeroknowledge.fm) podcast.


| Podcast | Title | Topic |
| ------- | ----- | ----- |
| [ZK 237](https://zeroknowledge.fm/237-2) | Exploring ZK Research with Jens Groth | Zero-knowledge proofs, Groth16 proof system |
| [ZK 244](https://zeroknowledge.fm/244-2) | Journey to Blockchain with David Tse | Consensus, Ethereum, David Tse |
| [ZK 256](https://zeroknowledge.fm/256-2) | New ZK Use Cases with Dan Boneh | Zero-knowledge proofs |
| [ZK 295](https://zeroknowledge.fm/295-2) | Return to MPC with Nigel Smart | Advanced Cryptography, multi-party computation |
